# Reporting

API Documentation: | `Reporting`

Known Subtypes: |
`Checkstyle` | `GenerateBuildDashboard` | `JDepend`
`CodeNarc` | `HtmlDependencyReportTask` | `Pmd`
`FindBugs` | `JacocoReport` | `Test`

An object that provides reporting options.

Tasks that produce reports as part of their execution expose configuration options of those reports via these methods. The `Reporting` interface is parameterized, where the parameter denotes the specific type of reporting container that is exposed. The specific type of the reporting container denotes the different types of reports available.

For example, given a task such as:

    class MyTask implements Reporting<MyReportContainer> {
        // implementation
    }

    interface MyReportContainer extends ReportContainer<Report> {
        Report getHtml();
        Report getCsv();
    }

The reporting aspects of such a task can be configured as such:

    task my(type: MyTask) {
        reports {
            html.enabled = true
            csv.enabled = false
        }
    }

See the documentation for the specific `ReportContainer` type for the task for information on report types and options.

### Properties

Property | Description
`reports` | A `ReportContainer` instance.

### Methods

No methods

### Script blocks

Block | Description
`reports` | Allow configuration of the report container by closure.

### Property details

#### `T` `reports` (read-only)

A `ReportContainer` instance.

Implementors specify a specific implementation of `ReportContainer` that describes the types of reports that are available.

### Script block details

#### `reports` { }

Allow configuration of the report container by closure.

    reports {
      html {
        enabled false
      }
      xml.destination "build/reports/myReport.xml"
    }

Delegates to:
  `T` from `reports`